echo off
set RegKey=HKEY_LOCAL_MACHINE\Software\Classes\*\Shell\RunCmdStart\
rem ----------------------------
if "%1" in [?,/?] goto Hilfe
if %1== goto Registry
if %1<>A1 goto Hilfe

rem ********* Parametereingabe ******************
Shift
set IstPrgm=
Info Extract NameExt "%1"
set Dateiname=%Info%
Info Extract Ext "%1"
for %%n in (.exe,.com,.bat,.cmd) do if %Info%==%%n {set IstPrgm=Ja}{goto Weiter}
:Weiter
if %IstPrgm% then {set Prompt=Mit welchem Parameter soll das Programm#10'%1'#10gestartet werden ?} \\
            {Else}{set Prompt=Mit welchem Parameter soll die Datei#10'%1'#10geffnet werden ?}
Load ParamInput
Input [,,400,350,Aufrufparameter fr "%Dateiname%",,D] "%Prompt%" /E:"%ParamInput%" /T:30
if %Info%<> Save ParamInput "%Info%"
if %IstPrgm% goto RunPrgm
:OpenFile
Error Aus
Open "%1" "%Info%"
Error Ein
if Errorlevel 1 goto ErrorOpen
goto Ende
:RunPrgm
Run "%1" "%Info%"
goto Ende

rem ********* Registry eintragen / lschen ******
:Registry
Info Reg "%RegKey%"
if %Info%== {goto InsReg}{Else}{goto DelReg}

rem  Aus der Registry lschen 
:DelReg
Ask [,,,#"RunCmd-Start" entfernen ?,B,V] "Den Eintrag 'RunCmd-Start' aus dem Explorer-Kontextmen entfernen ?" &Ja;&/Nein
if %ErrorLevel%==2 goto Ende
Sys RegDel "%RegKey%" /OE/OR
Ton Done
echo [,,,#Entfernen aus dem Explorer-Kontextmen]
echo ^ZRF^#10Der Eintrag "RunCmd-Start" wurde aus dem Explorer-Kontextmen entfernt !#10
goto Ende

rem  In die Registry eintragen 
:InsReg
Ask [,,,#"RunCmd-Start" hinzufgen ?,B,V] "Den Eintrag 'RunCmd-Start' dem Explorer-Kontextmen hinzufgen ?" &Ja;&/Nein
if %ErrorLevel%==2 goto Ende
Sys RegIns "%RegKey%" STR "ber &RunCmd mit Parameter ffnen oder starten"
Info RunCmd Prgm
Sys RegIns "%RegKey%\Command\" STR ""%Info%" "%0" A1 "%%1""
Ton Done
echo [,,,#Hinzufgen zum Explorer-Kontextmen]
echo ^ZNF^#10Der Eintrag "RunCmd-Start" wurde dem Explorer-Kontextmen hinzugefgt !#10
goto Ende

rem ********* Fehler ****************************
:ErrorOpen
Ton Error
echo .
echo [,,300,#Fehler beim ffnen einer Datei]
echo ^ZRN^Es gibt kein Standardprogramm zum ffnen der Datei
echo ^ZRN^"%1"
echo .
goto Ende

rem ********* Hilfe *****************************
:Hilfe
Info Extract NameExt "%0"
Ton Ding2
echo [,,,#Hilfe]
echo ^ZGB^Programm mit Parametereingabe ffnen
echo .
echo ^BNN^Fgt den Befehl "ber RunCmd mit Parameter ffnen oder starten" zum Explorer-Kontextmen hinzu.  \\
          Mit Hilfe dieses Befehls kann beim Start eines Programms bzw. beim ffnen einer Datei ein Parameter eingegeben werden.
echo .
echo ^ZNN^Aufruf:|f %Info%
echo .
goto Ende

rem ********* Ausgang ***************************
:Ende
