echo off
if "%1" in [?,/?] then goto Hilfe
setL EigeneIpAdr=00.00.00.00  ;; Die tatschliche eigene IP-Adresse muss hier eingetragen werden
setL IpAdrVar   =%1
setL IpAdrTxt   =%2
setL TempFile   =%Temp%\$$$IP$$$

rem ********* Bestimmung der IP-Adresse *********
GoSub GetIpAdr-RunCmd    @IpAdr1
GoSub GetIpAdr-nsLookup  @IpAdr2  "%TempFile%"
if "%$1,1$IpAdrVar%"<>"@" then {GoSub Ergebnisausgabe "%EigeneIpAdr%" "%IpAdr1%" "%IpAdr2%"}{goto Ende}
setL %IpAdrVar%=%IpAdr1% / %IpAdr2%
if "%IpAdrTxt%"<>"/Text" then goto Ende
if "%IpAdr1%"==""              and "%IpAdr2%"==""              then setL %IpAdrVar%=nicht gefunden
if "%IpAdr1%"=="%EigeneIpAdr%" and "%IpAdr2%"=="%EigeneIpAdr%" then setL %IpAdrVar%=eigene IP - %EigeneIpAdr%
goto Ende

rem ********* Unterprogramme ********************
:GetIpAdr-RunCmd
'Bestimmung der IP-Adresse ber "RunCmd"
'1. Parameter: Verweise auf eine lokale Variable zur Rckgabe der IP-Adresse
Info IpAdr Public
setL %1=%Info%
Return
'
:GetIpAdr-nsLookup
'Bestimmung der IP-Adresse ber "nslookup"
'1. Parameter: Verweise auf eine lokale Variable zur Rckgabe der IP-Adresse
'2. Parameter: Dateiname der Temporrdatei
' setL TempFile=%2
' cmd min nslookup.exe   myip.opendns.com   resolver1.opendns.com > "%TempFile%"
' Info Read "%TempFile%" 1 0 Zle /OD /Local /S:3
' setL ZleAnz=%Errorlevel%
' Info Trim Zle005
' setL Adr=%$1,9$Zle005%
' Info Trim Adr
' setL IpAdr=%$10,999$Zle005%
' Info Trim IpAdr
' Info VarPos IpAdr "." 0 1
' if (%Errorlevel%<>3) or ("%Adr%"<>"Address:") then setL IpAdr=
' setL %1=%IpAdr%
'
' Info Read diagnostic.opendns.com /MaxLen:600
Info Read https://diagnostic.opendns.com/myip
setL %1=%Info%
Return

rem ********* Ergebnisausgabe *******************
:Ergebnisausgabe
setL EigeneIp=%1
setL IpAdr1  =%2
setL IpAdr2  =%3
if "%IpAdr1%"=="" and "%IpAdr2%"==""  then {Ton Error}{setL Format=^ZRFD^}{setL Txt=Die IP-Adresse konnte nicht bestimmt werden !} \\
                                     {Else}{Ton Done }{setL Format=^ZNND^}{setL Txt=IP-Adresse: |f%IpAdr1% / %IpAdr2%}{Sys Clipboard %IpAdr1% /$Clear$}
if "%IpAdr1%"=="%EigeneIp%" and "%IpAdr2%"=="%EigeneIp%" then setL Txt=Eigene %Txt%
Echo [,,300,#IP-Adresse,V] ^ZNN3^#10%Format%%Txt%#10^ZNN3^
Return

rem ********* Hilfe *****************************
:Hilfe
Info Extract NameExt "%0"
Ton  Ding2
setL Hilfe=^ZGFB^Bestimmt die Internet-IP-Adresse#10 \\
           ^ZNN7^#10 \\
           ^LNNB^|^10^Aufruf:|^60^|f%Info%   [@VarName]   [/Text]#10 \\
           ^ZNN3^#10 \\
           ^LNFB^|^60^@VarName|^135^:|^145^|fVerweis auf eine lokale Variable, in der die IP-Adresse gespeichert wird (z.B. '%Info%' @IpAdr).#10 \\
           ^LNNB^                    |^145^Wird keine IP-Adresse gefunden, ist der Variablenwert leer, sofern der Schalter '/Text' fehlt.#10 \\
           ^LNFB^|^60^/Text   |^135^:|^145^|fNur von Bedeutung, wenn ein Variablenverweis vorhanden ist:#10 \\
           ^LNNB^                    |^145^IP-Adresse gefunden       |^310^: Variable enthlt die IP-Adresse#10 \\
           ^LNNB^                    |^145^IP-Adresse nicht gefunden |^310^: Variable enthlt 'nicht gefunden'#10 \\
           ^LNNB^                    |^145^Eigene IP-Adresse gefunden|^310^: Variable enthlt 'eigene IP Adresse'#10 \\
           ^ZNN3^#10 \\
           ^LNNB^|^60^Fehlt der Variablenwert, wird die IP-Adresse in einem Meldungsfenster angezeigt.#10 \\
           ^ZNN3^
:HilfeAsk
Ask [,,,#Hilfe,I,H,700] "%Hilfe%" /&OK;&Kopie
if %Errorlevel%==2 then {Info RemoveFormat %Hilfe% /$Clipboard$}{goto HilfeAsk}
goto Ende

rem ********* Ausgang ***************************
:Ende
