echo off
'Einstellung der RunCmd-Programm-Standardwerte
'
'Die Standard-Schriftarten mssen im Abschnitt "Standardwerte ndern"
'durch installierte Schriftarten ersetzt werden.
'

rem ----- Abfrage ------------------------------------------
Ask "RunCmd auf Standardwerte zurcksetzen ?" &Ja;&/Nein
if Errorlevel 2 goto Ende

rem ----- Standardwerte ndern -----------------------------
Defaults /DL:D /DF:A /DS:9 /DA:L            ;;Programmsprache Deutsch
                                            ;;Standardschrift Arial
                                            ;;Schriftgre 9 Punkt
                                            ;;Echo-Ausrichtung links
Defaults /DZ:"B-Blippo-Heavy"               ;;Schriftartzuordnung "B": Blippo-Heavy
Defaults /DZ:"D-Dixieland"                  ;;Schriftartzuordnung "D": Dixieland
Defaults /DZ:"E-Technical"                  ;;Schriftartzuordnung "E": Technical
Defaults /DZ:"F-Freeport"                   ;;Schriftartzuordnung "F": Freeport
Defaults /DZ:"G-LCD"                        ;;Schriftartzuordnung "G": LCD
Defaults /DZ:"H-Handschrift"                ;;Schriftartzuordnung "H": Handschrift
Defaults /DZ:"I-Comic Sans MS"              ;;Schriftartzuordnung "I": Comic Sans MS
Defaults /DZ:"J-Blippo-Hollow"              ;;Schriftartzuordnung "J": Blippo-Hollow
Defaults /DZ:"K-Arial Black"                ;;Schriftartzuordnung "K": Arial Black
Defaults /DZ:"L-Letter Gothic"              ;;Schriftartzuordnung "L": Letter Gothic
Defaults /DZ:"M-Stamp"                      ;;Schriftartzuordnung "M": Stamp
Defaults /DZ:"N-Arial Narrow"               ;;Schriftartzuordnung "N": Arial Narrow
Defaults /DZ:"O-LineDraw"                   ;;Schriftartzuordnung "O": LineDraw
Defaults /DZ:"P-Penguin"                    ;;Schriftartzuordnung "P": Penguin
Defaults /DZ:"Q-Lucida Console"             ;;Schriftartzuordnung "Q": Lucida Console
Defaults /DZ:"R-OCR-B"                      ;;Schriftartzuordnung "R": OCR-B
Defaults /DZ:"S-Symbol"                     ;;Schriftartzuordnung "S": Symbol
Defaults /DZ:"U-BrushScript-Normal-Italic"  ;;Schriftartzuordnung "U": BrushScript-Normal-Italic
Defaults /DZ:"V-ShelleyAllegro BT"          ;;Schriftartzuordnung "V": ShelleyAllegro BT
Defaults /DZ:"W-WingDings"                  ;;Schriftartzuordnung "W": WingDings
Defaults /DZ:"Y-Frankenstein"               ;;Schriftartzuordnung "Y": Frankenstein
Defaults /DZ:"Z-ZurichCalligraphic"         ;;Schriftartzuordnung "Z": ZurichCalligraphic

rem ----- Standardwerte anzeigen ---------------------------
Info Defaults
set Defaults=%Info%
for %%n in (A..Z) do {Info Defaults Font%%n}{set Font%%n=%Info%}
echo [,,,#RunCdm-Standardeinstellungen] /T:-5
echo Sprache         |^100^: %$5,1$Defaults%
echo Schriftart      |^100^: Font %$11,1$Defaults% (%%Font%$11,1$Defaults%%%)
echo Schriftgre    |^100^: %$17,2$Defaults+0%
echo Echo-Ausrichtung|^100^: %$24,1$Defaults%
echo .
echo ^xxxC^|[9Font A|^40^= |[C"|(A%FontA%|(A"|[9     |^250^Font N|^290^= |[C"|(N%FontN%|(A"
echo ^xxxC^|[9Font B|^40^= |[C"|(B%FontB%|(A"|[9     |^250^Font O|^290^= |[C"|(O%FontO%|(A"
echo ^xxxC^|[9Font C|^40^= |[C"|(C%FontC%|(A"|[9     |^250^Font P|^290^= |[C"|(P%FontP%A(A"
echo ^xxxC^|[9Font D|^40^= |[C"|(D%FontD%|(A"|[9     |^250^Font Q|^290^= |[C"|(Q%FontQ%|(A"
echo ^xxxC^|[9Font E|^40^= |[C"|(E%FontE%|(A"|[9     |^250^Font R|^290^= |[C"|(R%FontR%|(A"
echo ^xxxC^|[9Font F|^40^= |[C"|(F%FontF%|(A"|[9     |^250^Font S|^290^= |[C"|(S%FontS%|(A"
echo ^xxxC^|[9Font G|^40^= |[C"|(G%FontG%|(A"|[9     |^250^Font T|^290^= |[C"|(T%FontT%|(A"
echo ^xxxC^|[9Font H|^40^= |[C"|(H%FontH%|(A"|[9     |^250^Font U|^290^= |[C"|(U%FontU%|(A"
echo ^xxxC^|[9Font I|^40^= |[C"|(I%FontI%|(A"|[9     |^250^Font V|^290^= |[C"|(V%FontV%|(A"
echo ^xxxC^|[9Font J|^40^= |[C"|(J%FontJ%|(A"|[9     |^250^Font W|^290^= |[C"|(W%FontW%|(A"
echo ^xxxC^|[9Font K|^40^= |[C"|(K%FontK%|(A"|[9     |^250^Font X|^290^= |[C"|(X%FontX%|(A"
echo ^xxxC^|[9Font L|^40^= |[C"|(L%FontL%|(A"|[9     |^250^Font Y|^290^= |[C"|(Y%FontY%|(A"
echo ^xxxC^|[9Font M|^40^= |[C"|(M%FontM%|(A"|[9     |^250^Font Z|^290^= |[C"|(Z%FontZ%|(A"
for %%n in (A..Z) do set Font%%n=
set Defaults=

'
:Ende
