echo off
Key <ReleaseShift>
if "%1"=="" then goto Abfrage
goto Hilfe
' Globale Variablen 
'TaskArr       : Array aller RunCmd-Tasks
'TasksAnz      : Anzahl der Elemente in "TaskArr"
'TaskArrDopp   : Array aller doppelten RunCmd-Tasks
'TasksAnzDopp  : Anzahl der Elemente in "TaskArrDopp"
'TaskArrClose  : Array aller zu schlieenden RunCmd-Tasks
'TasksAnzClose : Anzahl der Elemente in "TaskArrClose"

rem ********* Abfrage ***************************
:Abfrage
set Self=%0
Info TaskList "RunCmd" TaskArr /-"%Self%" /C:TFL /P:R.exe /Title /S:4
set TasksAnz=%Errorlevel%
if %TasksAnz%<=0 goto KeineInstanz

' Instanzen gefunden 
setL Zeilen=
set  TasksAnzClose=0000
set  TasksAnzDopp =0000
for %%n in (0001..%TasksAnz%) do {GoSub GetTaskName  %%n  @Task} \\
                                 {if "%Task%"<>"" then {if "%Zeilen%"<>"" then setL Zeilen=%Zeilen%#10}{setL Zeilen=%Zeilen%%Task%}}
if %TasksAnzClose%==1 then goto EineInstanz
goto MehrereInstanzen

' Keine Instanz gefunden 
:KeineInstanz
Ton  Ding3
Echo [,,450,#Kein RunCmd,V] ^ZNNB^#10^ZGNC^Es luft keine weitere Instanz von RunCmd !#10^ZNNB^ /T:-2
goto Ende

' Eine Instanz gefunden 
:EineInstanz
if %TasksAnz%==1 then {setL Prompt1=Es luft eine weitere Instanz von RunCmd:}{setL Prompt2=Soll sie beendet werden ?  } \\
                {Else}{setL Prompt1=Es laufen weitere Instanzen von RunCmd:  }{setL Prompt2=Sollen sie beendet werden ?}
Ask [,,450,"RunCmd beenden ?",B,V] "^ZNNB^%Prompt1% #10^ZNN3^#10^ZGNB^%Zeilen%#10^ZNN3^#10^ZNNB^%Prompt2%" &Beenden;&/Abbrechen
if %ErrorLevel%==2 then goto Abbruch
GoSub CloseAllInstances
goto Ende

' Mehrere Instanzen gefunden 
:MehrereInstanzen
setL Prompt=Sollen die folgenden %TasksAnz% Instanzen#10von RunCmd beendet werden ?
if %TaskAnzClose%>=10 then goto MehrereInstanzen_1
'
setL Tmp=%Zeilen%
setL Zeilen=
Info Calc %TasksAnzClose% /V:0
setL Anz=%Info%
for %%n in (1..%Anz%) do {Info SubParam Tmp ##10 %%n}{setL Zeilen=%Zeilen%&%%n - %Info%}{if %%n<<%Anz% then setL Zeilen=%Zeilen%#10}
'
Info CharStr 1 %TasksAnzClose%
setL SelStr=%Info%
Select [CL,,,,#RunCmd-Instanzen beenden,RunCmd-Instanzen beenden,B,V] "^ZNN3^#10^ZNNC^%Prompt%#10^ZNN3^" /E:%SelStr%
Select %Zeilen%
setL SelStr=%Info%
if %Errorlevel%>>0 or %SelStr%==0 then goto Abbruch
Info CharStr 1 %TasksAnzClose%
if %SelStr%==%Info% then {GoSub CloseAllInstances}{goto Ende}
setL CloseAnz=0
for %%n in (0001..%TasksAnzClose%) do if %$%%n,1$SelStr%==1 then GoSub CloseInstance "%%TaskArrClose%%n%%" @CloseAnz
if %CloseAnz%>>0 then Ton Recycled /W
goto Ende

rem ********* Unterprogramme ********************
:GetTaskName
'Bestimmt den Tasknamen und trgt gefundene, nicht doppelte Tasks in "TaskArrClose" ein
'1. Parameter: Index in "TaskArr"
'2. Parameter: Lokale Variable fr die Rckgabe des Tasknamens
setL Idx=%1
Info VarReplace TaskArr%Idx% " 
setL Task=%%TaskArr%Idx%%%
' Prften, ob der Taskname bereits in "TaskArrDopp" enthalten ist 
if %TasksAnzDopp%>>0 then for %%n in (0001..%TasksAnzDopp%) do if "%Task%"=="%%TaskArrDopp%%n%%" {setL %2=}{Return}
' Mehrfache Tasknamen in "TaskArrDopp" eintragen 
setL MehrfachAnz=1
if %Idx%<<%TasksAnz% then for %%n in (%+1&Idx%..%TasksAnz%) do {setL Tmp=%%TaskArr%%n%%}{Info VarReplace Tmp  " }{if "%Task%"=="%Tmp%" then {inc MehrfachAnz}{inc TasksAnzDopp /D}{set TaskArrDopp%TasksAnzDopp%=%Task%}}
' Task in TaskArrClose eintragen 
inc TasksAnzClose /D
set TaskArrClose%TasksAnzClose%=%Task%
' Tasknamen krzen 
Info VarPos Task "RunCmd:"
if %Errorlevel%>>0 then {setL Task=%$%+7&Errorlevel%,999$Task%}{Info Trim Task}
if %MehrfachAnz%>>1 then setL Task=%Task% (%MehrfachAnz% mal)
setL %2=%Task%
Return
'
:CloseAllInstances
setL Counter=9
:CloseAllInstances1
Win Close "RunCmd" /-"%Self%" /C:TFL /P:R.exe /Max:9
Wait 27
Info Win  "RunCmd" /-"%Self%" /C:TFL /P:R.exe
if %Errorlevel%>=1 and %Counter%>=1 then {dec Counter}{goto CloseAllInstances1}
if %Counter%>=1 then {Ton Recycled /W}{Else}{Ton Error /W}
Return
'
:CloseInstance
setL Counter=9
setL Task=%1
setL CloseAnz=%2
setL Closed=0
Info VarReplace Task  "
:CloseInstance1
Win Close "%Task%" /C:TFL /P:R.exe /Max:99 /All
if %Errorlevel%>>0 then inc Closed,%Errorlevel%
Wait 27
Info Win "%Task%" /C:TFL /P:R.exe
if %Errorlevel%>=1 and %Counter%>=1 then {dec Counter}{goto CloseInstance1}
if %Counter%>=1 then {inc %CloseAnz%,%Closed%}{if %Closed%>=1 then Ton Plop /W}{Else}{Ton Error /W}
Return

rem ********* Hilfe *****************************
:Hilfe
Info Extract NameExt "%0"
Ton  Ding2
Echo [,,,#Hilfe,H]
echo ^ZGFB^RunCmd-Instanzen beenden
echo ^ZNN7^
echo ^ZNNB^Aufruf: f%Info%
echo ^ZNN3^
goto Ende

rem ********* Ausgang ***************************
:Abbruch
Ton Abbruch /W
:Ende
for %%n in (0001..%TasksAnz%     ) do set TaskArr%%n     =
for %%n in (0001..%TasksAnzDopp% ) do set TaskArrDopp%%n =
for %%n in (0001..%TasksAnzClose%) do set TaskArrClose%%n=
set TasksAnz     =
set TasksAnzDopp =
set TasksAnzClose=
