echo off
if "%1" in [?,/?] goto Hilfe
set RegKey=HKey_Current_User\Software\Microsoft\Windows\CurrentVersion\Run

rem ********* Laufwerksbuchstabe eingeben *******
set Prompt=
set Drives=
set Counter=1
for %%n in (A..Z) do {Info DrvType %%n} \\
           {if %Info%<>Fixed then \\
               {set Prompt=%Prompt%%%n}{set Drives=%Drives%%%n}{inc Counter} \\
               {if %Counter%<=5 then \\
                  {set Prompt=%Prompt%;}{Else}{set Counter=1}{set Prompt=%Prompt%#10}}}
rem ---- Promptstring krzen ---
if %Counter%<=1 then {Info VarLen Prompt}{set Prompt=%$1,%-3Errorlevel%$Prompt%} \\
               {Else}{for %%n in (%Counter%..5) do set Prompt=%Prompt%#;}{Info VarLen Prompt}{set Prompt=%$1,%-1Errorlevel%$Prompt%}
set Counter=
Info VarLen Drives
set DrivesAnz=%Errorlevel%
rem ---- Eingabe ---------------
Ask [,,0,#Subst,B,H,250]
Ask "^B^Laufwerksbuchstabe, dem ein Verzeichnis zugeordnet werden oder dessen Verzeichnis-zuordnung aufgehoben werden soll:"
Ask [27]%Prompt% #10
Ask [155]/~Abbrechen
if %Errorlevel%>>%DrivesAnz% goto Ende
Set SubstDrive=%$%Errorlevel%,1$Drives%
set RegKey="%RegKey%\Subst%SubstDrive%"
set Drives=

rem ********* Pfad eingeben *********************
Info Subst %SubstDrive%
set SubstPfadAlt=%Info%
if "%SubstPfadAlt%"=="" then {set Prompt=}  \\
                       {Else}{set Prompt=#10Ist die Eingabe ein Leerstring, wird die Zuordnung von#10'%SubstPfadAlt%' zu %SubstDrive%: gelscht.}
Load SubstPfad "C:\Eigene Dateien\"
Input [,,0,300,#Subst,,V,H] /E:"%SubstPfad%"
Input "Verzeichnis, das dem Laufwerksbuchstaben %SubstDrive%: zugeordnet werden soll.
Input %Prompt%"
if Errorlevel 1 goto Ende
set SubstPfad=%Info%

rem ********* Permanent ? ***********************
if "%SubstPfad%"=="" then goto RemoveSubst
:MakeSubst
if "%$1,7$SubstPfadAlt%"=="\Device" then {set Permanent=Nein}{goto AskSubstEnde}
if not ExistDir "%SubstPfad%" goto ErrorMakeSubst
Save SubstPfad "%SubstPfad%"
set Prompt=Soll die Zuordnung von#10'|f%SubstPfad%|f'#10 zum Laufwerk |f%SubstDrive%:|f#10dauerhaft (auch nach dem Booten aktiv) sein ?
goto AskSubst
:RemoveSubst
if "%SubstPfadAlt%"=="" goto ErrorRemoveSubst
Info Reg %RegKey%
if %Info%== then {set Permanent=Nein}{goto AskSubstEnde}
set Prompt=Soll die Aufhebung der Zuordnung von#10'|f%SubstPfadAlt%|f'#10 zum Laufwerk |f%SubstDrive%:|f#10dauerhaft (auch nach dem Booten inaktiv) sein ?
:AskSubst
Ask [,,0,#Subst,B,H] "%Prompt%" &Ja;&~Nein;/&Abbrechen
if %Errorlevel%==3 goto Ende
if %Errorlevel%==2 {set Permanent=Nein}{Else}{set Permanent=Ja}
:AskSubstEnde

rem ********* Subst *****************************
if "%SubstPfadAlt%"=="" then goto SubstAusfhren
if "%SubstPfad%"=="" then {set Prompt=Sind Sie sicher, dass diese Zuordnung aufgehoben werden soll ?} \\
                    {Else}{set Prompt=Sind Sie sicher, dass das Verzeichnis in dieser Zuordnung durch '%SubstPfad%' ersetzt werden soll ?}
Ask [,,0,#ACHTUNG,W,V,300]
Ask "^BNN^Dem Laufwerksbuchstaben %SubstDrive%: ist zur Zeit das Verzeichnis '%SubstPfadAlt%' zugeordnet.  \\
    Die Aufhebung dieser Zuordnung kann dazu fhren, dass das System nicht mehr richtig funktioniert und neu gebootet werden muss!#10#10
Ask ^BRN^%Prompt%"
Ask &Ja;/&~Nein
if %Errorlevel%==2 goto Ende
:SubstAusfhren
Sys Subst %SubstDrive% "%SubstPfad%" /OE
if not %Permanent% {Ton Done /W}{goto Ende}
if "%SubstPfad%"=="" goto DelReg

rem ********* In die Registry eintragen *********
:InsReg
Info RunCmd Prgm
set SubstRegEintrag="%Info%" Sys Subst %SubstDrive%: "%SubstPfad%"
Info Reg %RegKey%
if "%Info%"=="%SubstRegEintrag%" then goto ErrorIns
Sys RegDel %RegKey% /OE/OR
Sys RegIns %RegKey% STR "%SubstRegEintrag%"
Ton Done
echo [,,,#Subst-Eintrag in die Registry]
echo ^ZNN^Die Zuordnung des Verzeichnisses
echo ^ZNF^"%SubstPfad%"
echo ^ZNN^zum Laufwerk |f%SubstDrive%:
echo ^ZNN^wurde in den Autostart-Schlssel
echo ^ZNF^%RegKey%
echo ^ZNN^der Registry eingetragen !
goto Ende

rem ********* Aus der Registry lschen **********
:DelReg
Sys RegDel %RegKey% /OE/OR
Ton Done
echo [,,,#Subst-Entfernung aus der Registry]
echo ^ZNN^Die Zuordnung des Verzeichnisses
echo ^ZNF^"%SubstPfadAlt%"
echo ^ZNN^zum Laufwerk |f%SubstDrive%:
echo ^ZNN^wurde aus dem Autostart-Schlssel
echo ^ZNF^%RegKey%
echo ^ZNN^der Registry entfernt !
goto Ende

rem ********* Fehler ****************************
:ErrorMakeSubst
Ton  Boing
echo [,,,#Subst-Fehler]
echo ^ZRF^#10Das Verzeichnis "%SubstPfad%" existiert nicht !#10
goto Ende
rem ---------------------------------------------
:ErrorRemoveSubst
Ton  Boing
echo [,,,#Subst-Fehler]
echo ^ZRF^#10Dem Laufwerk %SubstDrive%: ist zur Zeit kein Verzeichnis zugeordnet !#10
goto Ende
rem ---------------------------------------------
:ErrorIns
Ton  Boing
echo [,,,#Fehler beim Eintragen in die Registry]
echo ^ZRN^Die Zuordnung des Verzeichnisses
echo ^ZRF^"%SubstPfad%"
echo ^ZRN^zum Laufwerk |f%SubstDrive%:
echo ^ZRN^ist bereits im Autostart-Schlssel
echo ^ZRF^%RegKey%
echo ^ZRN^der Registry eingetragen !
goto Ende
rem ---------------------------------------------
:ErrorDel
Ton  Boing
echo .
echo [,,,#Fehler beim Lschen aus der Registry]
echo ^ZRN^Die Zuordnung des Verzeichnisses
echo ^ZRF^"%SubstPfad%"
echo ^ZRN^zum Laufwerk |f%SubstDrive%:
echo ^ZRN^ist nicht im Autostart-Schlssel
echo ^ZRF^%RegKey%
echo ^ZRN^der Registry eingetragen !
goto Ende

rem ********* Hilfe *****************************
:Hilfe
Info Extract NameExt "%0"
Ton  Ding2
echo [,,,#Hilfe,H]
echo ^ZGFB^Zuordnung eines Verzeichnisses zu einem Laufwerksbuchstaben
echo .
echo ^ZNN^Aufruf: |f%Info%
echo .
goto Ende

rem ********* Ausgang ***************************
:Ende
