echo off
'berprft, welche Zeit zur Ausfhrung eines Befehl notwendig ist.
'1. Den zu berprfende Befehl in der Schleife im Mittelteil des Programms eingeben.
'2. Die Anzahl der Ausfhrungen in der Variablen "LoopAnz" vereinbaren.
'   Ist "LoopAnz" zu gro, dauert die Programmausfhrung sehr lange.
'   Ist "LoopAnz" zu klein, wird das Ergebnis zu ungenau.
'   Daher mit einem kleinen Wert von "LoopAnz" beginnnen und bis zu einer 
'   vernnftigen Laufzeit (5 bis 10 Sekunden) erhhen.
'3. Programm ausfhren.
'------------------------------------------------------------------------------------

set LoopAnz=10000
break on

'--- Leerschleife ------------------
Info Timer Ein
for %%n in (1..%LoopAnz%) do 
Info Timer Aus
set ZeitLeer=%Errorlevel%

' Schleife der Testbefehle 
set EnvVar1=20060102
Info Timer Ein
for %%n in (1..%LoopAnz%) do {set EnvVar2=%$3,3$EnvVar1%}  ;; Befehl zwischen den geschwungenen Klammern durch den Testbefehl ersetzen
Info Timer Aus
set EnvVar1=
set EnvVar2=
'

'--- Ausgabe -----------------------
set ZeitGes=%%-%ZeitLeer%Errorlevel%%
Info Calc %ZeitGes%,000/%LoopAnz%
set ZeitBef=%Info%
Info Calc %ZeitGes%/1000,000
set ZeitGes=%Info%
Echo [,,,#Laufzeittest]
Echo ^ZNB^Testbefehl %LoopAnz% mal ausgefhrt
Echo .
Echo ^LNN^Laufzeit gesamt    |^112^: %ZeitGes% Sekunden
Echo ^LNN^Laufzeit pro Befehl|^112^: %ZeitBef% Millisekunden
'
