echo off
' Variablen:
'      IpAdrA : Gesamte Anfangs-IP-Adresse
'      IpAdrAA: Erste drei Bytes der Anfangs-IP-Adresse (mit abschlieendem Punkt)
'      IpAdrAE: Letztes    Byte  der Anfangs-IP-Adresse
'      IpAdrE : Gesamte End-IP-Adresse
'      IpAdrEE: Letztes Byte der End-IP-Adresse
'
set Timeout=500
if "%1" in [?,/?] goto Hilfe

rem ********* Anfangsabfrage ********************
'--- Beginn-Adresse --------
Load PingLanIpAdr /E:IpAdrA
if "%IpAdrA%"=="" then GoSub FindLanAdressen
GoSub SplitLanAdressen
Ton Photo
:AbfrageA
Input [,,300,170,#Ping,IP-Adressbereich,N,V] "^ZNN3^#10^ZNNB^Untere IP-Adresse:#10^ZNNA^(Leer = Standard-Adresse eintragen)#10^ZNN3^" /E:"%IpAdrA%"
if ErrorLevel 1 goto Ende
Info DelChar Info " "
if %Info%== then {GoSub FindLanAdressen}{GoSub SplitLanAdressen}{goto AbfrageA}
set IpAdrA=%Info%
{GoSub TestIpAdresse "%IpAdrA%"}{if %Errorlevel%==1 then {Ton Error}{goto AbfrageA}}
GoSub SplitIpAdresse "%IpAdrA%" IpAdrAA IpAdrAE
'--- End-Adresse -----------
:AbfrageE
Input [,,300,70,#Ping,IP-Adressbereich,N,V] "^ZNN3^#10^ZNNB^Obere IP-Adresse:#10%IpAdrAA% ...#10^ZNN3^" /E:"%IpAdrEE%" /Len:3 /Min:%IpAdrAE% /Max:255 /UD
if ErrorLevel 1 goto Ende
set IpAdrEE=%Info%
if not %IpAdrEE% in [0..255] then {Ton Error}{goto AbfrageE}
set IpAdrE=%IpAdrAA%%IpAdrEE%
Save PingLanIpAdr %IpAdrA%;%IpAdrEE%
'--- Timeout ---------------
Load PingLanTimeout /E:Timeout
Info Calc %Timeout%/1000
Input [,,300,45,#Ping,Timeout,N,V] "^ZNN3^#10^ZNNB^Ping-Timeout in Sekunden:#10^ZNNA^(0,1 bis 5 s)#10^ZNN3^" /E:%Info% /Min:0,1/Max:5 /UD:0,1
if ErrorLevel 1 goto Ende
Info Calc 1000*%Info%
set Timeout=%Info%
Save PingLanTimeout %Timeout%

rem ********* Ausfhrung ********************
Info Calc %IpAdrEE%-%IpAdrAE%
set Anzahl=%Info%
set LfdNr=0
set Ergebnis=
EchoOp [,,400,#Ping luft ...] ^ZNN7^#10^ZNNB^ /BE/AB:"Abbruch:berprfung abbrechen?"
for %%n in (%IpAdrAE%..%IpAdrEE%) do {inc LfdNr}{EchoTx "Die IP-Adresse  %IpAdrAA%%%n  wird geprft" /Zeile:2 /BE:"%LfdNr%/%Anzahl%"}{Net Ping %IpAdrAA%%%n /T:%Timeout%}{if %Errorlevel%>=0 then set Ergebnis=%Ergebnis%#10^ZNNB^%IpAdrAA%%%n}
EchoCl
set Txt=^ZNN3^#10^ZNNB^
if "%Ergebnis%"=="" then {set Txt=%Txt%Keine erreichbaren}{Else}{set Txt=%Txt%Erreichbare}
set Txt=%Txt% IP-Adressen im Bereich#10%IpAdrA%  %IpAdrE%
if "%Ergebnis%"=="" then {set Txt=%Txt%#10^ZNN3^}{Else}{set Txt=%Txt%:#10^ZNN3^%Ergebnis%}
Ton DingK
echo [,,,#Ping-Ergebnis,V] %Txt%
goto Ende

rem ********* Unterprogramme ****************
:FindLanAdressen
set IpAdrA=
Info IPAdr
setL IpAdr=%Info%
for %%n in (1..%Errorlevel%) do {Info SubParam IpAdr ##10 %%n}{GoSub TestLanAdresse "%Info%"}{if "%IpAdrA%"<>"" then goto FindLanAdresseEnde}
set IpAdrA=192.168.0.100
:FindLanAdresseEnde
GoSub SplitIpAdresse "%IpAdrA%" IpAdrAA IpAdrAE
set IpAdrA=%IpAdrAA%100;120
Return
'
:TestLanAdresse
setL Byte1=%1
Info SubParam Byte1 "." 1
if %Info% in [10,172,192] then set IpAdrA=%1
Return
'---------------------------
:SplitLanAdressen
Info VarPos IpAdrA ";"
set IpAdrEE=%$%+1&Errorlevel%,255$IpAdrA%
set IpAdrA =%$1,%-1&Errorlevel%$IpAdrA%
GoSub SplitIpAdresse "%IpAdrA%" IpAdrAA IpAdrAE
set IpAdrE=%IpAdrAA%%IpAdrEE%
Return
'---------------------------
:SplitIpAdresse 
setL IpAdr=%1
Info VarPos IpAdr "." 3
set %2=%$1,%Errorlevel%$IpAdr%
set %3=%$%+1&Errorlevel%,255$IpAdr%
Return
'---------------------------
:TestIpAdresse
setL IpAdr=%1
Info VarPos IpAdr "." 0
if %Errorlevel%<>3 then {set Errorlevel=1}{Return}
for %%n in (1..4) do {Info SubParam IpAdr "." %%n}{if not %Info% in [0..255] then {set Errorlevel=1}{Return}}
set Errorlevel=0
Return

rem ********* Abbruch ***************************
:Abbruch
Shift CallLevel 999
Ton Ende /W
goto Ende

rem ********* Hilfe *****************************
:Hilfe
Info Extract NameExt "%0"
Ton  Ding2
Echo [,,,#Hilfe,H]
echo ^ZGFB^berprfung, welche IP-Adressen eines Adressbereich antworten
echo ^ZNN7^
echo ^ZNNB^Aufruf: |f%Info%
echo ^ZNN3^
goto Ende

rem ********* Ausgang ***************************
:Ende
