echo off
if "%1"<> goto Help
set D7zr=7zR.exe
set D7zS=7zS.sfx

rem ********* CMD-Name bestimmen ****************
:Dateinamen
Info Extract NameExt "%0"
for %%n in (*.cmd) do if "%%n"<>"%Info%" then set CmdName=%%n
if %CmdName%== then goto Help

rem ********* Pfade berprfen ******************
DrvDir Save
GoSub Pfadeingabe 7-Zip  Zip7Dir   %D7zR%  %D7zS%
GoSub Pfadeingabe RunCmd RunCmdDir R.exe
DrvDir Restore
goto Dateinamen
'
:Pfadeingabe
Load %2
set Pfad=%%%2%
if %$-1,1$Pfad%==\ then {Info VarLen Pfad}{set Pfad=%$1,%-1Errorlevel%$Pfad%}{set %2=%Pfad%}
if Exist "%Pfad%\%3" then {if %4== then {goto PfadeingabeEnde}{Else}{if Exist "%Pfad%\%4" then goto PfadeingabeEnde}}
goto Pfadeingabe1
:PfadeingabeEnde
set %2=%Pfad%
set Pfad=
Return
:Pfadeingabe1
set Prompt=Pfad des Programms '%3'
set Dateiauswahl=%3
if %4<> then {set Prompt=%Prompt% und der Datei '%4'}{set Dateiauswahl=%Dateiauswahl%;%4}
Input [,300,,250,#%1-Verzeichnis,,V,H] "^ZNN3^#10^ZNNB^%Prompt%:#10^ZNN9^(Nur Verzeichnis, ohne Dateiname)#10^ZNN3^" /E:"%Pfad%" /DM:%Dateiauswahl%
set Prompt=
set Dateiauswahl=
if %Errorlevel%>=1 then {Ton Abbruch /W}{goto Ende}
set %2=%Info%
Save %2 "%Info%"
goto Pfadeingabe

rem ********* Dateinamen eingeben ***************
:Dateinamen
Gosub Dateinameneingabe Cmd cmd CmdName Exist    "Name der CMD-Datei, die beim Aufruf#10der EXE-Commanddatei gestartet wird"
Info Extract Name "%CmdName%"
set ExeName=%Info%.exe
Gosub Dateinameneingabe Exe exe ExeName NotExist "Name der zu erstellenden EXE-Datei"
goto RExt
'
:Dateinameneingabe
set Dateiname=%%%3%
Info Extract Ext "%Dateiname%"
if %Info%<>.%2 then set Dateiname=%Dateiname%.%2
Input [,300,,150,#%1-Datei,,D,H] "^ZNN3^#10^ZNNB^%5:#10^ZNN3^" /E:"%Dateiname%" /DM:*.%2
if %ErrorLevel%>=1 then {Ton Abbruch /W}{goto Ende}
Info Extract NameExt %Info%
set Dateiname=%Info%
Info Extract Ext %Dateiname%
if %Info%<>.%2 then set Dateiname=%Dateiname%.%2
set %3=%Dateiname%
Info VarLen Dateiname
if %Errorlevel%<=4 then goto Dateinameneingabe
if %4==Exist    then if not Exist %Dateiname% then {goto Dateinameneingabe}{Else}{goto Ende-Dateinameneingabe}
if %4==NotExist and not Exist %Dateiname% then goto Ende-Dateinameneingabe
Ton DingK
Ask [,300,,#berschreiben ?,B,V,330]
Ask "^ZNN3^#10^ZNNB^Die Datei '%Dateiname%' existiert bereits.#10Soll sie berschrieben werden ?#10^ZNN3^" ~&Ja;&Nein;&Abbrechen
if %ErrorLevel%==3 then {Ton Abbruch /W}{goto Ende}
if %Errorlevel%==2 then goto Dateinameneingabe
Del "%Dateiname%" /OA/OD/OE/OR
:Ende-Dateinameneingabe
set Dateiname=
Return

rem ********* RExt.exe einbinden ? **************
:RExt
set RExtPfad="%RunCmdDir%\RExt.exe"
Ask [,300,,#RExt.exe einbinden ?,B,V,330]
Ask "^ZNN3^#10^ZNFB^Soll das Programm 'RExt.exe' in die zu erstellende#10Datei '%ExeName%' eingebunden werden ?#10
Ask ^ZNN7^#10^BNNB^Das Einbinden von 'RExt.exe' vergrert die zu erstellende EXE-Datei, ist aber fr folgende RunCmd-Befehle notwendig:#10
Ask ^BNNB^|^20^Info|^55^#09Autorun#10
Ask ^BNNB^|^20^Info|^55^#09TasklistWin#10
Ask ^BNNB^|^20^Sys |^55^#09DrvLetter#10
Ask ^BNNB^|^20^Sys |^55^#09Wallpaper#10
Ask ^BNNB^|^20^Ton |^55^#09Aus, Ein, Ende, Klingel, Notify, Open, Recycled, Screech, Trommel, Tromp#10^ZNN3^"
Ask &Ja;~&Nein;&Abbrechen
if %ErrorLevel%==3 then {Ton Abbruch /W}{goto Ende}
if %Errorlevel%==2 then set RExtPfad=

rem ********* Skript erstellen ******************
:Ausfhrung
Info Shortname %CmdName%
set Script=MakeExe7z.txt
echo {>%Script%<}
echo ;!@Install@!UTF-8!
echo Title=""
echo BeginPrompt=""
echo Progress="no"
echo RunProgram="R.exe /$OA %Info%"
echo GUIMode="2"
echo Directory=""
echo ;!@InstallEnd@!
echo

rem ********* Paken *****************************
Info Extract Name "%ExeName%"
set Archiv=%Info%.7z
Info Extract NameExt "%0"
cmd min "%Zip7Dir%\%D7zR%" a "%Archiv%" -t7z -m0=BCJ2 -m1=LZMA:d25:fb255 -m2=LZMA:d19 -m3=LZMA:d19 -mb0:1 -mb0s1:2 -mb0s2:3 -mhc=on -mx=9 *.cmd "%RunCmdDir%\R.exe" %RExtPfad% -x!"%Info%"
merge "%Zip7Dir%\%D7zS%"+"%Script%"+"%Archiv%" "%ExeName%" /OA/OD/OE/OR
del "%Archiv%" /OA/OD/OE/OR
del "%Script%" /OA/OD/OE/OR
Ton  Done
echo [,300,400,#Programm beendet,V] ^ZNN3^#10^ZNFC^Die Datei "%ExeName%" wurde erstellt !#10^ZNN3^
goto Ende

rem ********* Hilfe *****************************
:Help
Info Extract NameExt "%0"
Ton  Ding2
Echo [,300,,#Hilfe,H,500]
echo ^ZMFBA^Erstellung selbstlaufender EXE-Programme aus CMD-Dateien#10mit Hilfe des Freeware-Packprogramms 7-Zip|h
echo ^LNNBA^
echo ^BNNAA^|^10^#09Zum Erstellen selbstlaufender RunCmd-Programme mit "%Info%" sind nur die beiden 7-Zip-Dateien "%D7zR%" und "%D7zS%" erforderlich. \\
                    Beide sind in "7z920_extra.7z" enthalten. Dieses Archiv kann (wie das gesamte 7-Zip-Packprogramm) kostenlos von "https://www.7-zip.org/download.html" heruntergeladen werden  \\
                   (Beschreibung: des "7z920_extra.7z"-Zusatzpakets: "7-Zip Extra: 7z Library, SFXs for installers, Plugin for Fare Manager").
echo ^LNNBA^                                                   
echo ^BNNAA^|^10^|(W|(A #09Alle bentigten CMD-Dateien und diese Datei "%Info%" mssen sich in einem eigens angelegten Verzeichnis befinden.
echo ^LNN3A^
echo ^BNNAA^|^10^|(W|(A #09Befinden sich auch andere (nicht erforderliche) Dateien in diesem Verzeichnis, werden sie ebenfalls in die zu  \\
                            erstellende EXE-Datei eingebunden und vergrern sie unntigerweise.
echo ^LNNBA^
goto Ende

rem ********* Ausgang ***************************
:Ende
Exit
